﻿<DebuggerStepThrough()> _
Public Class MyRelayCommand
  Implements ICommand

#Region "Fields"

  ReadOnly _execute As Action
  ReadOnly _canExecute As Func(Of Boolean)

#End Region
#Region "Constructors"

  Public Sub New(execute As Action)
    Me.New(execute, Nothing)
  End Sub

  Public Sub New(execute As Action, canExecute As Func(Of Boolean))
    If execute Is Nothing Then
      Throw New ArgumentNullException("execute")
    End If

    _execute = execute
    _canExecute = canExecute
  End Sub
#End Region
#Region "ICommand Members"

  <DebuggerStepThrough()> _
  Public Function CanExecute(parameter As Object) As Boolean Implements ICommand.CanExecute
    Return If(_canExecute Is Nothing, True, _canExecute.Invoke)
  End Function


  Public Custom Event CanExecuteChanged As EventHandler Implements ICommand.CanExecuteChanged
    AddHandler(ByVal value As EventHandler)
      AddHandler CommandManager.RequerySuggested, value
    End AddHandler
    RemoveHandler(ByVal value As EventHandler)
      RemoveHandler CommandManager.RequerySuggested, value
    End RemoveHandler
    RaiseEvent(ByVal sender As System.Object, ByVal e As System.EventArgs)
    End RaiseEvent
  End Event

  <DebuggerStepThrough()> _
  Public Sub Execute(ByVal parameter As Object) Implements ICommand.Execute
    _execute.Invoke()
  End Sub

#End Region

End Class


<DebuggerStepThrough()> _
Public Class MyRelayCommand(Of T)
  Implements ICommand

#Region "Fields"

  ReadOnly _execute As Action(Of T)
  ReadOnly _canExecute As Func(Of T, Boolean)

#End Region
#Region "Constructors"

  Public Sub New(execute As Action(Of T))
    Me.New(execute, Nothing)
  End Sub

  Public Sub New(execute As Action(Of T), canExecute As Func(Of T, Boolean))
    If execute Is Nothing Then
      Throw New ArgumentNullException("execute")
    End If

    _execute = execute
    _canExecute = canExecute
  End Sub
#End Region
#Region "ICommand Members"

  <DebuggerStepThrough()> _
  Public Function CanExecute(parameter As Object) As Boolean Implements ICommand.CanExecute
    Return If(_canExecute Is Nothing, True, _canExecute(DirectCast(parameter, T)))
  End Function


  Public Custom Event CanExecuteChanged As EventHandler Implements ICommand.CanExecuteChanged
    AddHandler(ByVal value As EventHandler)
      AddHandler CommandManager.RequerySuggested, value
    End AddHandler
    RemoveHandler(ByVal value As EventHandler)
      RemoveHandler CommandManager.RequerySuggested, value
    End RemoveHandler
    RaiseEvent(ByVal sender As System.Object, ByVal e As System.EventArgs)
    End RaiseEvent
  End Event

  <DebuggerStepThrough()> _
  Public Sub Execute(ByVal parameter As Object) Implements ICommand.Execute
    _execute(DirectCast(parameter, T))
  End Sub

#End Region

End Class